#ifndef _SCRIPT_ELEMENT_H
#define _SCRIPT_ELEMENT_H

bool LoadScript(void);

class CScriptElement
{
public:
	CScriptElement();
	CScriptElement *pNextElement;
	virtual void Run(void);
	virtual char * Create(char * args);
	int team;
};

class CElementSetType: public CScriptElement
{
public:
	CElementSetType();
	void Run(void);
	char  * Create(char *args);
private:
	int waypoint;
	int flag;
	bool isnot;
};

class CElementSetTeam: public CScriptElement
{
public:
	CElementSetTeam();
	void Run(void);
	char  * Create(char *args);
private:
	int waypoint;
	int toteam;
};

class CElementReverseCTF: public CScriptElement
{
public:
	CElementReverseCTF();
	void Run();
	char * Create(char * args);
private:
	bool on;
};

class CElementSameAs: public CScriptElement
{
public:
	CElementSameAs();
	~CElementSameAs();
	void Run();
	char * Create(char * args);
private:
	char * string;
};


typedef struct message_s
{
	struct message_s *pNextMessage;
	class CScriptElement * pElements;
	char message[82];
} message_t;

#endif


